# Arena Survival Tournament

This is one of my first game prototype.
It's fully coded in C with SDL2 and SDL2_image libs.
All SDL2 parts and sub-parts are under the same license as SDL2 lib.
All code of AST are covered by the MIT license.

## Functions

The game can do following and you can learn from that like we do when you created this code:
- Generate random maps level
- Control a simple IA
- Manage gold resources
- Players movements
- Bad code practice

## Compiling

Before compiling, you need to install your favorite compiler (GCC or MSVC) with CMake and the lib manager Conan (https://conan.io):

```shell
# For debian based distribution:
apt update
apt install build-essential cmake conan
```

Clone the repo and launch in order conan and cmake in order to compile the program:

```shell
cd AST
mkdir build && cd build
cp -R ../data .
conan install .. --build=missing
cmake .. # or with '-G "MinGW Makefiles"' if under Windows
make
```

## Running

Simply run the program with `data` folder (required) and `logs` folder (optional) or use the launch script.