#ifndef MAIN_H_
#define MAIN_H_

#define A_WIDTH 30
#define A_HEIGHT 30

#define TILE_SIZE 32
#define WINDOWS_WIDTH TILE_SIZE * A_WIDTH
#define WINDOWS_HEIGHT TILE_SIZE * A_HEIGHT

/*
 * Generator tiles spawn rate (in percent)
 */
#define ROCK_GEN_RATE 28
#define TREE_GEN_RATE 22
#define WATER_GEN_RATE 8
#define GOLD_GEN_RATE 10

enum {DOWN, UP, LEFT, RIGHT};
enum {GRASS, ROCK, TREE, WATER, GOLD, SPAWN};

int random_lim(int max);

#endif
